# Terraform GCP BigTable Module
Terraform module for provisioning Big Table Instance

## Usage
For usage details, please navigate to [examples](./examples/basic/bigtable).

## Inputs
| Name | Description | Type | Default | Required |
|------|-------------|:----:|:-----:|:-----:|
| `bt_insance` | Cloud Bigtable instance with cluster properties. | map | {} | Yes |
| `name` | The name (also called Instance Id in the Cloud Console) of the Cloud Bigtable instance. | string | - | Yes |
| `cluster` | A block of cluster configuration options. This can be specified at least once, and up to 4 times. | map | {} | Yes |
| `cluster_id` | The ID of the Cloud Bigtable cluster. | string | - | Yes |
| `zone` | The zone to create the Cloud Bigtable cluster in. If it not specified, the provider zone is used. | string | - | No |
| `num_nodes` |  The number of nodes in your Cloud Bigtable cluster. | string | - | No |
| `storage_type` | The storage type to use. One of SSD or HDD | string | - | No |
| `kms_key_name` |  Describes the Cloud KMS encryption key that will be used to protect the destination Bigtable cluster.  | string | - | No |
| `bt_table` | Map of Big table table related values like table name and column family. | map | {} | No |
| `name` |  The name of the table. | string | - | Yes |
| `instance_name` |  The name of the Bigtable instance. | string | - | Yes |
| `split_keys` |   A list of predefined keys to split the table on.| string | - | No |
| `column_family` |   A group of columns within a table which share a common configuration. | string | - | No |
| `project ` |  The ID of the project in which the resource belongs. If it is not provided, the provider project is used. | string | - | No |
| `bt_gc_policy` | Creates Bigtab Garbage Collection policy that manages automatic process of removing expired data. | map | {} | No |
| `table` | The name of the table. | string | - | Yes |
| `column_family` | The name of the column family. | map | {} | Yes |
| `mode` |  If multiple policies are set, you should choose between UNION OR INTERSECTION. | string | - | No |
| `max_age` | GC policy that applies to all cells older than the given age. | string | - | No |
| `max_version` | GC policy that applies to all versions of a cell except for the most recent. | string | - | No |
| `bt_iam_policy` | Manages Big table instance iam policy. IAM Group level policy example is shown below. | map | {} | No |
| `member/members ` | Identities that will be granted the privilege in role. Each entry can have one of the following values: | string | - | Yes |
| `role ` | The role to be applied. Note that custom roles must be of the format projects/organizations/parent-name/roles/role-name. | string | - | Yes |
| `policy_data` | The policy data generated by a google_iam_policy data source. | string | - | Yes |

## Outputs
| Name | Description |
|------|-------------|
| `bt_instance_id` | The bigtable instance ID. | 
| `bt_instance_display_name` | Display name for bigtable instance | 

## Prerequisites

For successful use of the module:

1. The version of project factory used in the project IaC should be at minimum version `v0.25.1`
2. The APIs which should be enabled in the project should be the following:
```
    "bigtable.googleapis.com",
    "iam.googleapis.com",
    "logging.googleapis.com",
    "monitoring.googleapis.com",
    "stackdriver.googleapis.com",
    "servicenetworking.googleapis.com",
    "cloudkms.googleapis.com",

```
3. The role that should be granted to the project resource editor in the BigTable project is `roles/bigtable.admin`. This role has the minimum permissions needed to create the BigTable instance.
4. The project IaC should ensure that the following outputs are configured, these are necessary since the  module will pick up values directly from the output of the TFE project workspace.
* `project_id`
* `shared_vpc_project_id`
* `kms_crypto_key`
5. The minimum version that should be used for the `google` and `google-beta` providers in the workspace where the cluster is being created is `3.9.0`

## Development

### Requirements

You will need the following packages in order to develop locally:
* terraform v0.12.31
* inspec